#ifndef __IMU_H
#define __IMU_H

#include "stm32h7xx_hal.h"
#include <stdio.h>
#include "stdint.h"
#include <string.h>


#define imu_step_0 0 
#define imu_step_1 1
#define imu_step_2 2





__packed typedef struct
{
uint8_t tag; /* data packet tag */
uint8_t id;
uint8_t rev[6]; /* reserved */
uint32_t ts; /* timestamp */
float acc[3];
float gyr[3];
float mag[3];
float eul[3]; /* eular angles: Roll,Pitch,Yaw */
float quat[4]; /* quaternion */
}id0x91_t;

typedef struct
{
  float accel_x;       // unit: gravity accelration  m/s2
  float accel_y;       // unit: gravity accelration  m/s2
  float accel_z;       // unit: gravity accelration  m/s2
  float gyro_x;        // unit: rad/s
  float gyro_y;        // unit: rad/s
  float gyro_z;        // unit: rad/s
	float q1;
	float q2;
	float q3;
	float q4;
  float eular_roll;    // unit: rad
  float eular_pitch;   // unit: rad
  float eular_yaw;     // unit: rad
}IMU_State;

void IMU_Status(void);


#endif




