#include "ring_buffer.h"



// 
void RingBuffer_Reset(RingBufferTypeDef *ringBuf){
	// ָβָ붼ָbuffer׸ַ
	ringBuf->head = 0;
	ringBuf->tail = 0;
}

// 
void RingBuffer_Init(RingBufferTypeDef* ringBuf, uint16_t capacity, uint8_t *buffer){
    // RingBufferTypeDef *ringBuf = (RingBufferTypeDef *)malloc(sizeof(RingBufferTypeDef));
	// Bufferڴɹ
	ringBuf->buffer = buffer;// (uint8_t *)malloc(ringBuf->size);
	ringBuf->head = 0;
	ringBuf->tail = 0;
	// ߴsizeҪcapacityһ
	ringBuf->size = capacity + 1;
	// ֵʼΪ0
	for (uint16_t i=0; i<ringBuf->size; i++){
		ringBuf->buffer[i] = 0;
	}
	// printf("[RingBuffer_Init] ring buffer init pbuffer=%p\n", ringBuf->buffer);
}

// ٶ
//void RingBuffer_Destory(RingBufferTypeDef *ringBuf){
//	free(ringBuf->buffer);
//	free(ringBuf);
//}

// ûζе
uint16_t RingBuffer_GetCapacity(RingBufferTypeDef *ringBuf){
	return ringBuf->size - 1;
}

// ȡζѾõֽ
uint16_t RingBuffer_GetByteUsed(RingBufferTypeDef *ringBuf){
	if (ringBuf->head > ringBuf->tail){
		return RingBuffer_GetCapacity(ringBuf) - (ringBuf->head - ringBuf->tail - 1);
	}else{
		return ringBuf->tail - ringBuf->head;
	}
}

// ȡеʣ
uint16_t RingBuffer_GetByteFree(RingBufferTypeDef *ringBuf){
	return RingBuffer_GetCapacity(ringBuf) - RingBuffer_GetByteUsed(ringBuf);
}

// жϻζǷΪ
uint8_t RingBuffer_IsEmpty(RingBufferTypeDef *ringBuf){
	return RingBuffer_GetByteFree(ringBuf) == RingBuffer_GetCapacity(ringBuf);
}

// жϻζǷ
uint8_t RingBuffer_IsFull(RingBufferTypeDef *ringBuf){
	return RingBuffer_GetByteFree(ringBuf) == 0;
}

// ŶȡiԪ
uint8_t RingBuffer_GetValueByIndex(RingBufferTypeDef *ringBuf, uint16_t index){
	if (index >= RingBuffer_GetByteUsed(ringBuf)){
		// ų˷Χ
		return 0;
	}
	uint16_t rbIdx = (ringBuf->head + index + 1) % ringBuf->size;
	return ringBuf->buffer[rbIdx];
}

// Ԫ
uint8_t RingBuffer_Pop(RingBufferTypeDef *ringBuf){
	uint8_t temp;
	if(RingBuffer_IsEmpty(ringBuf)){
		return 0;
	}
	else{
		ringBuf->head =(ringBuf->head + 1)%ringBuf->size;
		temp = ringBuf->buffer[ringBuf->head];
		ringBuf->buffer[ringBuf->head] = 0;
		return temp;
	}
	
}


// дβԪ
void RingBuffer_Push(RingBufferTypeDef *ringBuf, uint8_t value){
	//printf("[RingBuffer_Push] before detect isFull\n");
	if (RingBuffer_IsFull(ringBuf)){
		// Ѿд, ֻȵ׵Ԫ
		RingBuffer_Pop(ringBuf);
	}
	ringBuf->tail =(ringBuf->tail + 1)%ringBuf->size;
	//printf("[RingBuffer_Push]  ringBuf tail index: %d\n", ringBuf->tail);
	ringBuf->buffer[ringBuf->tail] = value;
	//printf("[RingBuffer_Push] tail %d\n", ringBuf->buffer[ringBuf->tail]);

}

// ȡֽ
uint8_t RingBuffer_ReadByte(RingBufferTypeDef *ringBuf){
	return RingBuffer_Pop(ringBuf);
}

// ȡֽ
void RingBuffer_ReadByteArray(RingBufferTypeDef *ringBuf, uint8_t* dest, uint16_t size){
	for(uint16_t idx=0; idx<size; idx++){
		dest[idx] = RingBuffer_Pop(ringBuf);
	}
}

// ȡзShort(ֽ)
int16_t RingBuffer_ReadShort(RingBufferTypeDef *ringBuf){
	int16_t value;
	uint8_t *p = (uint8_t *)&value;
	RingBuffer_ReadByteArray(ringBuf, p, 2);
	return value;
}
 
// ȡ޷Short(ֽ)
uint16_t RingBuffer_ReadUShort(RingBufferTypeDef *ringBuf){
	uint16_t value;
	uint8_t *p = (uint8_t *)&value;
	RingBuffer_ReadByteArray(ringBuf, p, 2);
	return value;
}

// ȡзLong͵(ĸֽ)
int32_t RingBuffer_ReadLong(RingBufferTypeDef *ringBuf){
	int32_t value;
	uint8_t *p = (uint8_t *)&value;
	RingBuffer_ReadByteArray(ringBuf, p, 4);
	return value;
}

// ȡ޷Long͵(ĸֽ)
uint32_t RingBuffer_ReadULong(RingBufferTypeDef *ringBuf){
	uint32_t value;
	uint8_t *p = (uint8_t *)&value;
	RingBuffer_ReadByteArray(ringBuf, p, 4);
	return value;
}

// ȡ(ĸֽ)
float RingBuffer_ReadFloat(RingBufferTypeDef *ringBuf){
	float value;
	uint8_t *p = (uint8_t *)&value;
	RingBuffer_ReadByteArray(ringBuf, p, 4);
	return value;
}

// д뵥ֽ
void RingBuffer_WriteByte(RingBufferTypeDef *ringBuf, uint8_t value){
	RingBuffer_Push(ringBuf, value);
}

// дֽ
void RingBuffer_WriteByteArray(RingBufferTypeDef *ringBuf, uint8_t* src, uint16_t size){
	for(uint16_t idx=0; idx<size; idx++){
		RingBuffer_Push(ringBuf, src[idx]);
	}
}
// дзShort(ֽ)
void RingBuffer_WriteShort(RingBufferTypeDef *ringBuf, int16_t value){
	uint8_t *p= (uint8_t *)&value;
	RingBuffer_WriteByteArray(ringBuf, p, 2);
}

// д޷Short(ֽ)
void RingBuffer_WriteUShort(RingBufferTypeDef *ringBuf, uint16_t value){
	uint8_t *p= (uint8_t *)&value;
	RingBuffer_WriteByteArray(ringBuf, p, 2);
}

// дзLong͵(ĸֽ)
void RingBuffer_WriteLong(RingBufferTypeDef *ringBuf, int32_t value){
	uint8_t *p= (uint8_t *)&value;
	RingBuffer_WriteByteArray(ringBuf, p, 4);
}

// д޷Long͵(ĸֽ)
void RingBuffer_WriteULong(RingBufferTypeDef *ringBuf, uint32_t value){
	uint8_t *p= (uint8_t *)&value;
	RingBuffer_WriteByteArray(ringBuf, p, 4);
}

// д븡(ĸֽ)
void RingBuffer_WriteFloat(RingBufferTypeDef *ringBuf, float value){
	uint8_t *p= (uint8_t *)&value;
	RingBuffer_WriteByteArray(ringBuf, p, 4);
}


// У
uint8_t RingBuffer_GetChecksum(RingBufferTypeDef *ringBuf){
	uint16_t nByte = RingBuffer_GetByteUsed(ringBuf);
	uint32_t bSum=0;
	// printf("[RingBuffer_GetChecksum] \r\n");
	// ָʼλ
	
	for(int i=0; i < nByte; i++){
		// ָ
		bSum = (bSum + RingBuffer_GetValueByIndex(ringBuf, i))% 256;
	}
	//У
	return bSum;
}
