#ifndef __RING_BUFFER_H
#define __RING_BUFFER_H

#include<stdio.h>
#include <string.h>
#include <stdlib.h>
#include "stm32h7xx_hal.h"

// ζнṹ
typedef struct
{  
    uint8_t *buffer; // 
    uint16_t head; // ָ
    uint16_t tail; // βָ
    uint16_t size; // ζеĳߴ
} RingBufferTypeDef;

// 
void RingBuffer_Init(RingBufferTypeDef* ringBuf, uint16_t capacity, uint8_t *buffer);
// 
void RingBuffer_Reset(RingBufferTypeDef *ringBuf);
// ٶ
void RingBuffer_Destory(RingBufferTypeDef *ringBuf);
// ȡе
uint16_t RingBuffer_GetCapacity(RingBufferTypeDef *ringBuf);
// ȡζѾõֽ
uint16_t RingBuffer_GetByteUsed(RingBufferTypeDef *ringBuf);
// ȡеʣĿֽ
uint16_t RingBuffer_GetByteFree(RingBufferTypeDef *ringBuf);
// ǷΪ
uint8_t RingBuffer_IsEmpty(RingBufferTypeDef *ringBuf);
// Ƿ
uint8_t RingBuffer_IsFull(RingBufferTypeDef *ringBuf);
// ŶȡiԪ
uint8_t RingBuffer_GetValueByIndex(RingBufferTypeDef *ringBuf, uint16_t index);
// Ԫ
uint8_t RingBuffer_Pop(RingBufferTypeDef *ringBuf);
// ȡֽ
uint8_t RingBuffer_ReadByte(RingBufferTypeDef *ringBuf);
// ȡֽ
void RingBuffer_ReadByteArray(RingBufferTypeDef *ringBuf, uint8_t* dest, uint16_t size);
// ȡзShort(ֽ)
int16_t RingBuffer_ReadShort(RingBufferTypeDef *ringBuf);
// ȡ޷Short(ֽ)
uint16_t RingBuffer_ReadUShort(RingBufferTypeDef *ringBuf);
// ȡзLong͵(ĸֽ)
int32_t RingBuffer_ReadLong(RingBufferTypeDef *ringBuf);
// ȡ޷Long͵(ĸֽ)
uint32_t RingBuffer_ReadULong(RingBufferTypeDef *ringBuf);
// ȡ(ĸֽ)
float RingBuffer_ReadFloat(RingBufferTypeDef *ringBuf);
// дβԪ
void RingBuffer_Push(RingBufferTypeDef *ringBuf, uint8_t value);
// д뵥ֽ
void RingBuffer_WriteByte(RingBufferTypeDef *ringBuf, uint8_t value);
// дֽ
void RingBuffer_WriteByteArray(RingBufferTypeDef *ringBuf, uint8_t* src, uint16_t size);
// дзShort(ֽ)
void RingBuffer_WriteShort(RingBufferTypeDef *ringBuf, int16_t value);
// д޷Short(ֽ)
void RingBuffer_WriteUShort(RingBufferTypeDef *ringBuf, uint16_t value);
// дзLong͵(ĸֽ)
void RingBuffer_WriteLong(RingBufferTypeDef *ringBuf, int32_t value);
// д޷Long͵(ĸֽ)
void RingBuffer_WriteULong(RingBufferTypeDef *ringBuf, uint32_t value);
// д븡(ĸֽ)
void RingBuffer_WriteFloat(RingBufferTypeDef *ringBuf, float value);
// 㻺ԼУ()
uint8_t RingBuffer_GetChecksum(RingBufferTypeDef *ringBuf);



#endif

