/**
  ******************************************************************************
  * @file    stm32h7xx_it.c
  * @brief   Interrupt Service Routines.
  ******************************************************************************
  *
  * COPYRIGHT(c) 2018 STMicroelectronics
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
/* Includes ------------------------------------------------------------------*/
#include "stm32h7xx_hal.h"
#include "stm32h7xx.h"
#include "stm32h7xx_it.h"

/* USER CODE BEGIN 0 */
#include "bsp_BasicTIM.h" 
#include "bsp_CAN.h"
#include "bsp_usart1.h"
#include "bsp_usart2.h"
#include "bsp_usart3.h"
#include "bsp_usart6.h"
#include "bsp_uart4.h"
#include "bsp_uart5.h"
#include "bsp_uart7.h"
#include "bsp_RS485.h"
#include "cmsis_os.h"
#define ERR_INFO "\r\nEnter HardFault_Handler, System Halt.\r\n"

/* USER CODE END 0 */
#define RX_MAX_COUNT              255      // ڽֽ








uint8_t  Robot_aRxBuffer[256];
__IO uint16_t RxCount1=0;                  // ѽյֽ
__IO uint8_t Frame_flag1=0;                // ֡־1һµ֡  0֡

uint8_t SBUS_aRxBuffer[256];
__IO uint16_t RxCount2=0;                  // ѽյֽ
__IO uint8_t Frame_flag2=0;                // ֡־1һµ֡  0֡

uint8_t usart3_aRxBuffer[256];
__IO uint16_t RxCount3=0;                  // ѽյֽ
__IO uint8_t Frame_flag3=0;                // ֡־1һµ֡  0֡

uint8_t IMU_aRxBuffer[256];
__IO uint16_t RxCount4=0;                  // ѽյֽ
__IO uint8_t Frame_flag4=0;                // ֡־1һµ֡  0֡

uint8_t usart5_aRxBuffer[256];
__IO uint16_t RxCount5=0;                  // ѽյֽ
__IO uint8_t Frame_flag5=0;                // ֡־1һµ֡  0֡

uint8_t usart6_aRxBuffer[256];
__IO uint16_t RxCount6=0;                  // ѽյֽ
__IO uint8_t Frame_flag6=0;                // ֡־1һµ֡  0֡


uint8_t usart7_aRxBuffer[256];
__IO uint16_t RxCount7=0;                  // ѽյֽ
__IO uint8_t Frame_flag7=0;                // ֡־1һµ֡  0֡\

uint8_t usart8_aRxBuffer[256];
__IO uint16_t RxCount8=0;                  // ѽյֽ
__IO uint8_t Frame_flag8=0;                // ֡־1һµ֡  0֡

/* External variables --------------------------------------------------------*/

/******************************************************************************/
/*            Cortex Processor Interruption and Exception Handlers         */ 
/******************************************************************************/

/**
* @brief This function handles Non maskable interrupt.
*/
void NMI_Handler(void)
{
  /* USER CODE BEGIN NonMaskableInt_IRQn 0 */

  /* USER CODE END NonMaskableInt_IRQn 0 */
  HAL_RCC_NMI_IRQHandler();
  /* USER CODE BEGIN NonMaskableInt_IRQn 1 */

  /* USER CODE END NonMaskableInt_IRQn 1 */
}

/**
* @brief This function handles Hard fault interrupt.
*/
void HardFault_Handler(void)
{
  /* USER CODE BEGIN HardFault_IRQn 0 */
#if 1
  const char *pError = ERR_INFO;
  uint8_t i;

  for (i = 0; i < sizeof(ERR_INFO); i++)
  {
     USART3->TDR = pError[i];
     /* ȴͽ */
     while ((USART3->ISR & USART_ISR_TC) == (uint16_t)RESET);
  }
#endif	
  /* USER CODE END HardFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_HardFault_IRQn 0 */
    /* USER CODE END W1_HardFault_IRQn 0 */
  }
  /* USER CODE BEGIN HardFault_IRQn 1 */

  /* USER CODE END HardFault_IRQn 1 */
}

/**
* @brief This function handles Memory management fault.
*/
void MemManage_Handler(void)
{
  /* USER CODE BEGIN MemoryManagement_IRQn 0 */

  /* USER CODE END MemoryManagement_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_MemoryManagement_IRQn 0 */
    /* USER CODE END W1_MemoryManagement_IRQn 0 */
  }
  /* USER CODE BEGIN MemoryManagement_IRQn 1 */

  /* USER CODE END MemoryManagement_IRQn 1 */
}

/**
* @brief This function handles Pre-fetch fault, memory access fault.
*/
void BusFault_Handler(void)
{
  /* USER CODE BEGIN BusFault_IRQn 0 */

  /* USER CODE END BusFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_BusFault_IRQn 0 */
    /* USER CODE END W1_BusFault_IRQn 0 */
  }
  /* USER CODE BEGIN BusFault_IRQn 1 */

  /* USER CODE END BusFault_IRQn 1 */
}

/**
* @brief This function handles Undefined instruction or illegal state.
*/
void UsageFault_Handler(void)
{
  /* USER CODE BEGIN UsageFault_IRQn 0 */

  /* USER CODE END UsageFault_IRQn 0 */
  while (1)
  {
    /* USER CODE BEGIN W1_UsageFault_IRQn 0 */
    /* USER CODE END W1_UsageFault_IRQn 0 */
  }
  /* USER CODE BEGIN UsageFault_IRQn 1 */

  /* USER CODE END UsageFault_IRQn 1 */
}

/**
* @brief This function handles Debug monitor.
*/
void DebugMon_Handler(void)
{
  /* USER CODE BEGIN DebugMonitor_IRQn 0 */

  /* USER CODE END DebugMonitor_IRQn 0 */
  /* USER CODE BEGIN DebugMonitor_IRQn 1 */

  /* USER CODE END DebugMonitor_IRQn 1 */
}

/**
* @brief This function handles System tick timer.
*/
void SysTick_Handler(void)
{
  /* USER CODE BEGIN SysTick_IRQn 0 */

  /* USER CODE END SysTick_IRQn 0 */
  HAL_IncTick();
  osSystickHandler();
  /* USER CODE BEGIN SysTick_IRQn 1 */

  /* USER CODE END SysTick_IRQn 1 */
}


/******************************************************************************/
/* STM32H7xx жϴ                                                 */
/* ʹõжϴ.                                        */
/* ļstartup_stm32h7xx.s,Իȡõжϴ   */
/*                                                                            */
/******************************************************************************/

/* USER CODE BEGIN 1 */
void BASIC_TIM_INT_FUN(void)
{
  /* USER CODE BEGIN TIM6_IRQn 0 */

  /* USER CODE END TIM6_IRQn 0 */
  HAL_TIM_IRQHandler(&htim6);
  /* USER CODE BEGIN TIM6_IRQn 1 */

  /* USER CODE END TIM6_IRQn 1 */
}

void FDCAN1_IT0_IRQHandler(void)
{
  /* USER CODE BEGIN FDCAN2_IT0_IRQn 0 */
	
  /* USER CODE END FDCAN2_IT0_IRQn 0 */
  HAL_FDCAN_IRQHandler(&hFDCan1);
  /* USER CODE BEGIN FDCAN2_IT0_IRQn 1 */
 
  /* USER CODE END FDCAN2_IT0_IRQn 1 */
}

void FDCAN2_IT0_IRQHandler(void)
{
  /* USER CODE BEGIN FDCAN2_IT0_IRQn 0 */

  /* USER CODE END FDCAN2_IT0_IRQn 0 */
  HAL_FDCAN_IRQHandler(&hFDCan2);
  /* USER CODE BEGIN FDCAN2_IT0_IRQn 1 */

  /* USER CODE END FDCAN2_IT0_IRQn 1 */
}

void MX_USART1_IRQHandler(void)
{
	portDISABLE_INTERRUPTS();	
	if(__HAL_USART_GET_FLAG(&husart1,USART_FLAG_RXNE)!= RESET) // жϣյ
		{
			uint8_t data;
			data=READ_REG(husart1.Instance->RDR); // ȡ
			if(RxCount1==0) // ½յ֡ڿж
			{
				__HAL_UART_CLEAR_FLAG(&husart1,USART_FLAG_IDLE); // жϱ־
				__HAL_UART_ENABLE_IT(&husart1,UART_IT_IDLE);     // ʹܿж	    
			}
			if(RxCount1<RX_MAX_COUNT)    // жϽջδ
			{
				Robot_aRxBuffer[RxCount1]=data;  // 
				RxCount1++;                // ӽֽ
			}
		}
		else	if(__HAL_USART_GET_FLAG(&husart1,USART_FLAG_IDLE)!= RESET) // ڿж
		{
			__HAL_UART_CLEAR_FLAG(&husart1,USART_FLAG_IDLE); // жϱ־
			__HAL_UART_DISABLE_IT(&husart1,UART_IT_IDLE);    // رտж
			Frame_flag1=1;		                                 // ֡λʶյһ֡
		}
	portENABLE_INTERRUPTS();	
  
}
void MX_USART2_IRQHandler(void)
{ 
	portDISABLE_INTERRUPTS();	
	if(__HAL_USART_GET_FLAG(&husart2,USART_FLAG_RXNE)!= RESET) // жϣյ
	{
		uint8_t data;
		data=READ_REG(husart2.Instance->RDR); // ȡ
		if(RxCount2==0) // ½յ֡ڿж
		{
			__HAL_UART_CLEAR_FLAG(&husart2,USART_FLAG_IDLE); // жϱ־
		  __HAL_UART_ENABLE_IT(&husart2,UART_IT_IDLE);     // ʹܿж	    
		}
		if(RxCount2<RX_MAX_COUNT)    // жϽջδ
		{
			SBUS_aRxBuffer[RxCount2]=data;  // 
			RxCount2++;                // ӽֽ
		}
	}
	else	if(__HAL_USART_GET_FLAG(&husart2,USART_FLAG_IDLE)!= RESET) // ڿж
	{
		__HAL_UART_CLEAR_FLAG(&husart2,USART_FLAG_IDLE); // жϱ־
		__HAL_UART_DISABLE_IT(&husart2,UART_IT_IDLE);    // رտж
		Frame_flag2=1;		                                 // ֡λʶյһ֡
	}
  portENABLE_INTERRUPTS();	
}
void MX_USART3_IRQHandler(void)
{
	portDISABLE_INTERRUPTS();	
	if(__HAL_USART_GET_FLAG(&husart3,USART_FLAG_RXNE)!= RESET) // жϣյ
		{
			uint8_t data;
			data=READ_REG(husart3.Instance->RDR); // ȡ
			if(RxCount3==0) // ½յ֡ڿж
			{
				__HAL_UART_CLEAR_FLAG(&husart3,USART_FLAG_IDLE); // жϱ־
				__HAL_UART_ENABLE_IT(&husart3,UART_IT_IDLE);     // ʹܿж	    
			}
			if(RxCount3<RX_MAX_COUNT)    // жϽջδ
			{
				usart3_aRxBuffer[RxCount5]=data;  // 
				RxCount3++;                // ӽֽ
			}
		}
		else	if(__HAL_USART_GET_FLAG(&husart3,USART_FLAG_IDLE)!= RESET) // ڿж
		{
			__HAL_UART_CLEAR_FLAG(&husart3,USART_FLAG_IDLE); // жϱ־
			__HAL_UART_DISABLE_IT(&husart3,UART_IT_IDLE);    // رտж
			Frame_flag3=1;		                                 // ֡λʶյһ֡
		}
		portENABLE_INTERRUPTS();	
}
void MX_UART4_IRQHandler(void)
{ 
	portDISABLE_INTERRUPTS();	
	if(__HAL_USART_GET_FLAG(&huart4,USART_FLAG_RXNE)!= RESET) // жϣյ
	{
		uint8_t data;
		data=READ_REG(huart4.Instance->RDR); // ȡ
		if(RxCount4==0) // ½յ֡ڿж
		{
			__HAL_UART_CLEAR_FLAG(&huart4,USART_FLAG_IDLE); // жϱ־
		  __HAL_UART_ENABLE_IT(&huart4,UART_IT_IDLE);     // ʹܿж	    
		}
		if(RxCount4<RX_MAX_COUNT)    // жϽջδ
		{
			IMU_aRxBuffer[RxCount4]=data;  // 
			RxCount4++;                // ӽֽ
		}
	}
	else	if(__HAL_USART_GET_FLAG(&huart4,USART_FLAG_IDLE)!= RESET) // ڿж
	{
		__HAL_UART_CLEAR_FLAG(&huart4,USART_FLAG_IDLE); // жϱ־
		__HAL_UART_DISABLE_IT(&huart4,UART_IT_IDLE);    // رտж
		Frame_flag4=1;		                                 // ֡λʶյһ֡
	}
  portENABLE_INTERRUPTS();
}

void MX_UART5_IRQHandler(void)
{
	portDISABLE_INTERRUPTS();		
	if(__HAL_USART_GET_FLAG(&huart5,USART_FLAG_RXNE)!= RESET) // жϣյ
	{
		uint8_t data;
		data=READ_REG(huart5.Instance->RDR); // ȡ
		if(RxCount5==0) // ½յ֡ڿж
		{
			__HAL_UART_CLEAR_FLAG(&huart5,USART_FLAG_IDLE); // жϱ־
		  __HAL_UART_ENABLE_IT(&huart5,UART_IT_IDLE);     // ʹܿж	    
		}
		if(RxCount5<RX_MAX_COUNT)    // жϽջδ
		{
			usart5_aRxBuffer[RxCount5]=data;  // 
			RxCount5++;                // ӽֽ
		}
	}
	else	if(__HAL_USART_GET_FLAG(&huart5,USART_FLAG_IDLE)!= RESET) // ڿж
	{
		__HAL_UART_CLEAR_FLAG(&huart5,USART_FLAG_IDLE); // жϱ־
		__HAL_UART_DISABLE_IT(&huart5,UART_IT_IDLE);    // رտж
		Frame_flag6=1;		                                 // ֡λʶյһ֡
	}
	portENABLE_INTERRUPTS();
}

void MX_USART6_IRQHandler(void)
{
 portDISABLE_INTERRUPTS();		
 if(__HAL_USART_GET_FLAG(&husart6,USART_FLAG_RXNE)!= RESET) // жϣյ
	{
		uint8_t data;
		data=READ_REG(husart6.Instance->RDR); // ȡ
		if(RxCount6==0) // ½յ֡ڿж
		{
			__HAL_UART_CLEAR_FLAG(&husart6,USART_FLAG_IDLE); // жϱ־
		  __HAL_UART_ENABLE_IT(&husart6,UART_IT_IDLE);     // ʹܿж	    
		}
		if(RxCount6<RX_MAX_COUNT)    // жϽջδ
		{
			usart6_aRxBuffer[RxCount6]=data;  // 
			RxCount6++;                // ӽֽ
		}
	}
	else	if(__HAL_USART_GET_FLAG(&husart6,USART_FLAG_IDLE)!= RESET) // ڿж
	{
		__HAL_UART_CLEAR_FLAG(&husart6,USART_FLAG_IDLE); // жϱ־
		__HAL_UART_DISABLE_IT(&husart6,UART_IT_IDLE);    // رտж
		Frame_flag6=1;		                                 // ֡λʶյһ֡
	}
	portENABLE_INTERRUPTS();
}
void MX_UART7_IRQHandler(void)
{
	portDISABLE_INTERRUPTS();
	if(__HAL_USART_GET_FLAG(&huart7,USART_FLAG_RXNE)!= RESET) // жϣյ
	{
		uint8_t data;
		data=READ_REG(huart7.Instance->RDR); // ȡ
		
		if(RxCount7<RX_MAX_COUNT)    // жϽջδ
		{
			usart7_aRxBuffer[RxCount7]=data;  // 
			if(usart7_aRxBuffer[RxCount7]==0x0A) // س/nӦASCII0x0A
			{
				Frame_flag7=1; // յһ֡
			}
			else
			{
				RxCount7++;    // ӽֽ		
			}				
		}		
	}
  portENABLE_INTERRUPTS();	
}
void MX_RS485_UART8_IRQHandler(void)
{
	portDISABLE_INTERRUPTS();
  if(__HAL_USART_GET_FLAG(&huart8_RS485,USART_FLAG_RXNE)!= RESET) // жϣյ
	{
		uint8_t data;
		data=READ_REG(huart8_RS485.Instance->RDR); // ȡ
		if(RxCount8==0) // ½յ֡ڿж
		{
			__HAL_UART_CLEAR_FLAG(&huart8_RS485,USART_FLAG_IDLE); // жϱ־
		  __HAL_UART_ENABLE_IT(&huart8_RS485,UART_IT_IDLE);     // ʹܿж	    
		}
		if(RxCount8<RX_MAX_COUNT)    // жϽջδ
		{
			usart8_aRxBuffer[RxCount8]=data;  // 
			RxCount8++;                // ӽֽ
		}
	}
	else	if(__HAL_USART_GET_FLAG(&huart8_RS485,USART_FLAG_IDLE)!= RESET) // ڿж
	{
		__HAL_UART_CLEAR_FLAG(&huart8_RS485,USART_FLAG_IDLE); // жϱ־
		__HAL_UART_DISABLE_IT(&huart8_RS485,UART_IT_IDLE);    // رտж
	}
	portENABLE_INTERRUPTS();	
}
/* USER CODE END 1 */
/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
